#include <winsock2.h>
#include <windows.h>

//   
#pragma pack(push, 1)

//#define __USEINTERCEPTLOADDLL
#define  GLOB_MAP_ID "{84E5CFE5-30F8-425D-8A2C-98CF9530C0A2}"
#define INTERCEPT_SENDTO 1
#define INTERCEPT_WSASENDTO 2
#define MAX_BUFFER_SZ 0xFFFF

struct jmp_far
{
  BYTE instr_push;  //    push
  LPVOID arg;         // push
  BYTE  instr_ret;    //    ret
};


BYTE old_sendto[sizeof(jmp_far)], old_WSASendTo[sizeof(jmp_far)]; //   6-    
LPVOID adr_sendto = NULL, adr_WSASendTo = NULL; //   
jmp_far jump_sendto, jump_WSASendTo; //     

//    
struct TLogData
{
  u_long saddr;
  u_long daddr;
  u_short sport;
  u_short dport;
  int len;
  char buf[MAX_BUFFER_SZ];
} LogData;

//     
struct TShareInf
{
  HWND AppWndHandle;
  HHOOK OldHookHandle;
#ifdef __USEINTERCEPTLOADDLL
  char Intercept_str[40];
#endif
} *ShareInf = NULL;

HANDLE hCurrentProcess = NULL;

int WINAPI Intercept_WSASendTo(SOCKET s, LPWSABUF lpBuffers, DWORD dwBufferCount, LPDWORD lpNumberOfBytesSent,
                               DWORD dwFlags, const struct sockaddr FAR * lpTo, int iTolen, LPWSAOVERLAPPED lpOverlapped,
                               LPWSAOVERLAPPED_COMPLETION_ROUTINE lpCompletionRoutine)
{
  int result;
  COPYDATASTRUCT CDS;
  struct sockaddr_in *peer, speer;
  SIZE_T written; // 
  int speer_len;

  //  6   .
  WriteProcessMemory(hCurrentProcess, adr_WSASendTo, &old_WSASendTo, sizeof(jmp_far), &written);
    //    
  result = ((int (__stdcall*)(SOCKET, LPWSABUF, DWORD, LPDWORD, DWORD, const struct sockaddr FAR *, int,
                              LPWSAOVERLAPPED, LPWSAOVERLAPPED_COMPLETION_ROUTINE))adr_WSASendTo)
                              (s, lpBuffers, dwBufferCount, lpNumberOfBytesSent, dwFlags, lpTo, iTolen,
                               lpOverlapped, lpCompletionRoutine);

  //   6        
  WriteProcessMemory(hCurrentProcess, adr_WSASendTo, &jump_WSASendTo, sizeof(jmp_far), &written);

  peer = (struct sockaddr_in *)lpTo;
  if (peer->sin_addr.s_addr != INADDR_BROADCAST) return result; //  
  LogData.daddr = peer->sin_addr.s_addr;
  LogData.dport = peer->sin_port;

  speer_len = sizeof(speer);
  getsockname(s, (struct sockaddr *)&speer, &speer_len);
  LogData.saddr = speer.sin_addr.s_addr;
  LogData.sport = speer.sin_port;

  LogData.len = (int)*lpNumberOfBytesSent;
  memcpy(LogData.buf, lpBuffers, LogData.len);

  CDS.dwData = INTERCEPT_WSASENDTO;
  CDS.cbData = 16 + LogData.len;
  CDS.lpData = &LogData;
  SendMessage(ShareInf->AppWndHandle, WM_COPYDATA, 0, (LPARAM)(LPVOID)&CDS);

  return result;
}

//   __srtdcall
int WINAPI Intercept_sendto (SOCKET s, const char * buf, int len, int flags, const struct sockaddr FAR *to, int tolen)
{
  int result;
  COPYDATASTRUCT CDS;
  struct sockaddr_in *peer, speer;
  SIZE_T written; // 
  int speer_len;

  //  6   .
  WriteProcessMemory(hCurrentProcess, adr_sendto, &old_sendto, sizeof(jmp_far), &written);
//  //  
//  result = sendto (s, buf, len, flags, to, tolen);
    //    
  result = ((int (__stdcall*)(SOCKET , const char *, int, int , const struct sockaddr FAR *, int))adr_sendto)(s, buf, len, flags, to, tolen);


  //   6        
  WriteProcessMemory(hCurrentProcess, adr_sendto, &jump_sendto, sizeof(jmp_far), &written);

  peer = (struct sockaddr_in *)to;
  if (peer->sin_addr.s_addr != INADDR_BROADCAST) return result; //  
  LogData.daddr = peer->sin_addr.s_addr;
  LogData.dport = peer->sin_port;

  speer_len = sizeof(speer);
  getsockname(s, (struct sockaddr *)&speer, &speer_len);
  LogData.saddr = speer.sin_addr.s_addr;
  LogData.sport = speer.sin_port;

  LogData.len = len;
  memcpy(LogData.buf, buf, len);

  CDS.dwData = INTERCEPT_SENDTO;
  CDS.cbData = 16 + len;
  CDS.lpData = &LogData;
  SendMessage(ShareInf->AppWndHandle, WM_COPYDATA, 0, (LPARAM)(LPVOID)&CDS);

  return result;
}

void Intercept(void)
{
  SIZE_T written; // 
  HMODULE hLib;

  //      
//  hLib = GetModuleHandle("wsock32.dll");
  hLib = GetModuleHandle("ws2_32.dll");
  if(hLib == NULL)
//  {
//    MessageBox(NULL, "Can`t load ws2_32.dll", "Error!", 0);
    return;
//  }
//------------------------------------------------------------------------------
  adr_sendto = (LPVOID)GetProcAddress(hLib, "sendto");
  if(adr_sendto == NULL)
//  {
//    MessageBox(NULL, "Can`t get adr_sendto", "Error!", 0);
    return;
//  }

  //     ,   
  //    :
  jump_sendto.instr_push = 0x68;
  jump_sendto.arg = (LPVOID)&Intercept_sendto;
  jump_sendto.instr_ret = 0xC3;

  //     6   API 
  ReadProcessMemory(hCurrentProcess, adr_sendto, &old_sendto, sizeof(jmp_far), &written);

  //        6- 
  WriteProcessMemory(hCurrentProcess, adr_sendto, &jump_sendto, sizeof(jmp_far), &written);
//------------------------------------------------------------------------------
//  hLib = GetModuleHandle("ws2_32.dll");

  adr_WSASendTo = (LPVOID)GetProcAddress(hLib, "WSASendTo");
  if(adr_WSASendTo == NULL)
//  {
//    MessageBox(NULL, "Can`t get adr_WSASendTo", "Error!", 0);
    return;
//  }

  //     ,   
  //    :
  jump_WSASendTo.instr_push = 0x68;
  jump_WSASendTo.arg = (LPVOID)&Intercept_WSASendTo;
  jump_WSASendTo.instr_ret = 0xC3;

  //     6   API 
  ReadProcessMemory(hCurrentProcess, adr_WSASendTo, &old_WSASendTo, sizeof(jmp_far), &written);

  //        6- 
  WriteProcessMemory(hCurrentProcess, adr_WSASendTo, &jump_WSASendTo, sizeof(jmp_far), &written);

}

void UnIntercept(void)
{
  SIZE_T written; // 
  // 6   .
  if (adr_sendto)
  {
    WriteProcessMemory(hCurrentProcess, adr_sendto, &old_sendto, sizeof(jmp_far), &written);
    adr_sendto = NULL;
  }
  if (adr_WSASendTo)
  {
    WriteProcessMemory(hCurrentProcess, adr_WSASendTo, &old_WSASendTo, sizeof(jmp_far), &written);
    adr_WSASendTo = NULL;
  }
}


//---------------------------------------------------------------------------
//          
//---------------------------------------------------------------------------
HINSTANCE hInstance;

BOOL APIENTRY DllMain(HMODULE hinst, DWORD reason, LPVOID lpvReserved)
{
 HANDLE MapHandle;

 hInstance = hinst; // DLL-
 switch (reason)
 {
   case DLL_PROCESS_ATTACH:
        hCurrentProcess = GetCurrentProcess(); //get a pseudohandle to the current process
        //       
        //       ,
        //       
        //  
        MapHandle = CreateFileMapping(INVALID_HANDLE_VALUE, NULL, PAGE_READWRITE, 0, sizeof(TShareInf), GLOB_MAP_ID);
        ShareInf = (TShareInf*)MapViewOfFile(MapHandle, FILE_MAP_ALL_ACCESS, 0, 0, sizeof(TShareInf));
#ifdef __USEINTERCEPTLOADDLL
        if (strcmp(ShareInf->Intercept_str, GLOB_MAP_ID) == 0)
#endif
          Intercept();
        break;
   case DLL_PROCESS_DETACH:
        UnIntercept();
        UnmapViewOfFile(ShareInf);
 }

 return true;
}




//---------------------------------------------------------------------------
//    ,         .
//---------------------------------------------------------------------------
LRESULT WINAPI HookProc(int code,WPARAM wParam,LPARAM lParam)
{
  return CallNextHookEx(ShareInf->OldHookHandle, code, wParam, lParam);
}


extern "C"
{

BOOL __declspec( dllexport ) WINAPI hook(HWND Wnd)
{
  bool Result;

  if (ShareInf != NULL)
  {

    ShareInf->AppWndHandle = Wnd;
    ShareInf->OldHookHandle = SetWindowsHookEx(WH_GETMESSAGE, (HOOKPROC)&HookProc, hInstance, 0);
    Result = ShareInf->OldHookHandle != 0;
  }
  else Result = false;

  return Result;
}

BOOL __declspec( dllexport ) WINAPI unhook(void)
{
  return UnhookWindowsHookEx(ShareInf->OldHookHandle);
}

#ifdef __USEINTERCEPTLOADDLL
// -   dll-
BOOL __declspec( dllexport ) WINAPI InterceptLoadDll(bool Value)
{
  if (ShareInf != NULL)
  {
    if (Value) strcpy(ShareInf->Intercept_str, GLOB_MAP_ID); else ShareInf->Intercept_str[0] = 0;
    return true;
  }
  else return false;
}
#endif

} //extern "C"

#pragma pack(pop)

