#pragma hdrstop
#include "ipv4.h"

//  
unsigned short rs_crc (unsigned short * buffer, int length)
{

    register int sum = 0;
    unsigned short answer = 0;
    register unsigned short *w = buffer;
    register int nleft = length;

    while (nleft > 1)
    {
        sum += *w++;
        nleft -= 2;
    }
    if (nleft == 1)
    {
        *(unsigned char *) (&answer) = *(unsigned char *) w;
        sum += answer;
    }
    sum = (sum >> 16) + (sum & 0xffff);
    sum += (sum >> 16);
    answer = ~sum;
    return (answer);
}

#include <windows.h>
//    TCP  UDP
unsigned short rs_pseudo_crc (char * data, int data_length, unsigned int src_addr, unsigned int dst_addr, int packet_length, unsigned char proto)
{
 char * buffer;
 unsigned int full_length;
 unsigned char header_length;
 pseudo_header ph;

 unsigned short p_crc;

 //    .
 ph.src_addr = src_addr;
 ph.dst_addr = dst_addr;
 ph.zero = 0;
 ph.proto = proto;
 ph.length = htons (packet_length);

 header_length = sizeof (pseudo_header);
 full_length = header_length + data_length;

 //  .
 buffer =(char *) calloc (full_length, sizeof (char));

 //  .
 memcpy (buffer, &ph, header_length);
 memcpy (buffer + header_length, data, data_length);

 //  CRC.
 p_crc = rs_crc ((unsigned short*) buffer, full_length);

 free (buffer);
 return p_crc;
}

