//---------------------------------------------------------------------------

#ifndef ldpacketH
#define ldpacketH
//---------------------------------------------------------------------------
#include "..\WinPcap\Include\packet32.h"

bool init_packet_dll(HMODULE hpacket);

BOOLEAN PacketGetAdapterNames(PTSTR pStr,PULONG  BufferSize);
LPADAPTER PacketOpenAdapter(PCHAR AdapterName);
VOID PacketCloseAdapter(LPADAPTER lpAdapter);
LPPACKET PacketAllocatePacket(void);
VOID PacketInitPacket(LPPACKET lpPacket,PVOID  Buffer,UINT  Length);
VOID PacketFreePacket(LPPACKET lpPacket);
BOOLEAN PacketReceivePacket(LPADAPTER AdapterObject,LPPACKET lpPacket,BOOLEAN Sync);
BOOLEAN PacketSendPacket(LPADAPTER AdapterObject,LPPACKET pPacket,BOOLEAN Sync);
BOOLEAN PacketSetHwFilter(LPADAPTER AdapterObject,ULONG Filter);
BOOLEAN PacketRequest(LPADAPTER  AdapterObject,BOOLEAN Set,PPACKET_OID_DATA  OidData);
BOOLEAN PacketSetBuff(LPADAPTER AdapterObject,int dim);
BOOLEAN PacketSetBpf(LPADAPTER AdapterObject,struct bpf_program *fp);
BOOLEAN PacketGetStats(LPADAPTER AdapterObject,struct bpf_stat *s);
BOOLEAN PacketGetNetType (LPADAPTER AdapterObject,NetType *type);
BOOLEAN PacketSetReadTimeout(LPADAPTER AdapterObject,int timeout);
BOOLEAN PacketSetMode(LPADAPTER AdapterObject,int mode);
BOOLEAN PacketSetNumWrites(LPADAPTER AdapterObject,int nwrites);

#endif
