//---------------------------------------------------------------------------
//  
//---------------------------------------------------------------------------

#pragma hdrstop

#include "LanGameSel.h"
#include "raw/LanGameRaw.h"
#include "api/LanGameApi.h"
#include "pcap/LanGamePcap.h"

int sel = 0;

bool StartLanGame(HWND hlb)
{
  if ( StartLanGameRaw(hlb) ) sel = 1; else
  if ( StartLanGamePcap(hlb) ) sel = 2; else
  if ( StartLanGameApi(hlb) ) sel = 3;  else
    sel = 0;
  return sel != 0;
}

void StopLanGame(void)
{
  switch(sel)
  {
    case 1: StopLanGameRaw(); break;
    case 2: StopLanGamePcap(); break;
    case 3: StopLanGameApi();
  }
}

