//---------------------------------------------------------------------------
//LanGame  RAW () - .
//    :
//rsdn.ru  '  '
//http://www.komsoft.ru/pma/sniffer.htm
//http://www.komsoft.ru/pma/gen_packet.htm
//---------------------------------------------------------------------------
#pragma hdrstop
//#pragma comment(lib, "ws2_32.lib")
//#include <winsock2.h>
#include "LanGameRaw.h"
#pragma pack(push, 1)
// IPv4
#include "..\ipv4.h"
// 
#include "..\LanGameLib.h"




static bool MyThreadTerminated;
#define MAX_BUFFER_SZ  8156
SOCKET raw_socket = INVALID_SOCKET;  //  .
static bool Work;
#define QUIT_MESSAGE  "QUIT MESSAGE\0"

static DWORD WINAPI MyThread(LPVOID lpParam)
{
  struct sockaddr_in target;  //  ,     sendto
  ip_header *iphdr; //   IP
  udp_header *udphdr; //   UDP
  int count; // 
  static char Buffer[MAX_BUFFER_SZ]; //
  LRESULT i, lbcount; //-   listbox
  char str[MAX_PATH];
  u_short dport, aport;

  HWND hl = (HWND)lpParam;

  while (!MyThreadTerminated)
  {
    // 
    count = recv( raw_socket, Buffer, MAX_BUFFER_SZ, 0 );
    if( count < sizeof(ip_header) ) continue; //  IP 
    iphdr = (ip_header *)Buffer; // IP
    if (iphdr->proto != IPPROTO_UDP) continue; //  UDP 
//#ifndef _DEBUG
    if (iphdr->daddr != INADDR_BROADCAST) continue; //   
//#endif

    iphdr->crc = 0; //   IP    

    udphdr = (udp_header *)(Buffer + 20); // UDP
    if (strcmp(QUIT_MESSAGE, Buffer + 28) == 0) break; //
    if (strcmp(TEST_MESSAGE, Buffer + 28) == 0) { Work = true; continue; } // 

    dport = udphdr->dport; // destination port

    lbcount =  SendMessage (hl, LB_GETCOUNT, 0, 0); // -   
    for (i = 0; i < lbcount; i++)
    {
       if (SendMessage(hl, LB_GETTEXT, i, (LPARAM)str) ==  LB_ERR) continue; //   
       if (!get_s_addr(GA(str), &iphdr->daddr)) continue; //  u_int    iphdr->daddr
       aport = GP(str); //   
       if (aport) udphdr->dport = htons(aport); else udphdr->dport = dport; //  0 ,   
       udphdr->crc = 0;
       udphdr->crc = rs_pseudo_crc ((char *)udphdr, count - 20, iphdr->saddr, iphdr->daddr, count - 20, IPPROTO_UDP); //    UDP
       //   sendto
       memset (&target, 0, sizeof (sockaddr_in));
       target.sin_family = AF_INET;
       target.sin_addr.s_addr = iphdr->daddr;
       target.sin_port = udphdr->dport;
       //
       WSACheck(sendto(raw_socket, Buffer, count, 0,(struct sockaddr *)&target, sizeof (sockaddr_in)),"Can't sendto raw raw_socket");
    } //for
  } //while

  return 0;
}

static HANDLE hMyThread = NULL;
#define SIO_RCVALL  0x98000001

bool StartLanGameRaw(HWND hlb)
{
  DWORD dThread;
  struct sockaddr_in peer;  //  
  u_int use_own_header = 1; //     
  u_long flag = 1; //  PROMISC /.

  if (raw_socket == INVALID_SOCKET)
  {
    //  
    raw_socket = socket(AF_INET, SOCK_RAW, IPPROTO_IP);
    if (raw_socket == INVALID_SOCKET)
    {
#ifdef _DEBUG
       MessageBox(0, "Can't open raw_socket", "Error", 0);
#endif
       StopLanGameRaw();
       return false;
    }

    // 
    ZeroMemory( &peer, sizeof(peer) );
    peer.sin_family = AF_INET;
    peer.sin_addr.s_addr = inet_addr(IpAddress);
    //  
    if (!WSACheck(bind(raw_socket, (SOCKADDR *)&peer, sizeof(SOCKADDR)), "Can't bind raw_socket"))
    {
      StopLanGameRaw();
      return false;
    }
    //.  
    ioctlsocket(raw_socket, SIO_RCVALL, &flag); //  promiscuous mode.
    //   RAW,   
    if (!WSACheck(setsockopt (raw_socket, IPPROTO_IP, 2, (char*)&use_own_header, sizeof(use_own_header)),
        "Can't set option RAW for raw_socket"))
    {
      StopLanGameRaw();
      return false;
    }
  }//if (!raw_socket)



  MyThreadTerminated = false;
  if (!hMyThread)
  { // 
    hMyThread = CreateThread(NULL, 0, MyThread, (LPVOID)hlb, 0, &dThread);
    if (!hMyThread) //   , 
    {
      StopLanGameRaw();
      return false;
    }
  }

  Work = false;
  if(!Test()) //  
  {
    StopLanGameRaw();
    return false;
  }
  Sleep(200);

  if (!Work) StopLanGameRaw();
  return Work;
}

void StopLanGameRaw(void)
{
  struct sockaddr_in peer;
  DWORD lpExitCode;
  SOCKET udp_quit_socket;

  MyThreadTerminated = true;
  if (hMyThread)
  {
    udp_quit_socket = socket( AF_INET, SOCK_DGRAM, 0 );

    if (udp_quit_socket != INVALID_SOCKET)
    {
      memset(&peer, 0, sizeof(sockaddr_in));
      peer.sin_addr.s_addr = inet_addr(IpAddress);
      peer.sin_family = AF_INET;
      peer.sin_port = htons(27015); //CS :)
      //      
      WSACheck(sendto(udp_quit_socket, QUIT_MESSAGE, sizeof(QUIT_MESSAGE), 0, ( struct sockaddr * )&peer, sizeof( peer )),"Can't sendto udp_quit_socket" );
      closesocket(udp_quit_socket);
      Sleep(200);
    }
#ifdef _DEBUG
    else MessageBox(0, "Can't open udp_quit_socket", "Error", 0);
#endif

    // 5  ?
    if ( WaitForSingleObject(hMyThread, 5000) != 0 )
    {
      //   thread,  
      GetExitCodeThread(hMyThread, &lpExitCode);
      TerminateThread(hMyThread, lpExitCode);
      WaitForSingleObject(hMyThread, 5000);
    }
    CloseHandle(hMyThread);
    hMyThread = NULL;
  }

  //  .
  if (raw_socket != INVALID_SOCKET)
  {
    closesocket(raw_socket);
    raw_socket = INVALID_SOCKET;
  }

}

#pragma pack(pop)








